/*
SQL> desc DEF$_AQCALL
 Name                            Null?    Type
 ------------------------------- -------- ----
 Q_NAME                                   VARCHAR2(30)
 MSGID                                    RAW(16)
 CORRID                                   VARCHAR2(128)
 PRIORITY                                 NUMBER
 STATE                                    NUMBER
 DELAY                                    DATE
 EXPIRATION                               NUMBER
 TIME_MANAGER_INFO                        DATE
 LOCAL_ORDER_NO                           NUMBER
 CHAIN_NO                                 NUMBER
 CSCN                                     NUMBER
 DSCN                                     NUMBER
 ENQ_TIME                                 DATE
 ENQ_UID                                  NUMBER
 ENQ_TID                         NOT NULL VARCHAR2(30)
 DEQ_TIME                                 DATE
 DEQ_UID                                  NUMBER
 DEQ_TID                                  VARCHAR2(30)
 RETRY_COUNT                              NUMBER
 EXCEPTION_QSCHEMA                        VARCHAR2(30)
 EXCEPTION_QUEUE                          VARCHAR2(30)
 STEP_NO                         NOT NULL NUMBER
 RECIPIENT_KEY                            NUMBER
 DEQUEUE_MSGID                            RAW(16)
 USER_DATA                                BLOB
*/

select 
  substr(Q_NAME,1,12) Q_NAME,
  to_char(CHAIN_NO,'999') C_N, to_char(RECIPIENT_KEY,'9999') R_K,
  to_char(CSCN,'99999999999999') CSCN, to_char(DSCN,'99999999999999') DSCN,
  to_char(STEP_NO,'999') S_N,
  ENQ_TIME, to_char(ENQ_UID,'999') E_U, substr(ENQ_TID,1,11) ENQ_TID,
  DEQ_TIME, to_char(DEQ_UID,'999') D_U, substr(DEQ_TID,1,11) DEQ_TID,
  substr(CORRID,1,4) CORR,
  to_char(PRIORITY,'999') PRI, to_char(STATE,'999') STA,
  substr(to_char(DELAY,'9999'),1,3) DELY, substr(EXPIRATION,1,3) EXP,
  substr(TIME_MANAGER_INFO,1,5) T_M_I, to_char(LOCAL_ORDER_NO,'99999') L_O_N,
  to_char(RETRY_COUNT,'999') R_C,
  substr(EXCEPTION_QSCHEMA,1,4) E_QS, substr(EXCEPTION_QUEUE,1,4) E_QU
from DEF$_AQCALL
;
/*
where
  rownum<10
;
*/

/*
Q_NAME       CORR PRI  STA  DEL EXP T_M_I L_O_N  C_N  CSCN            DSCN            ENQ_TIME E_U  ENQ_TID     DEQ_TIME D_U  DEQ_TID     R_C  E_QS E_QU S_N  R_K
------------ ---- ---- ---- --- --- ----- ------ ---- --------------- --------------- -------- ---- ----------- -------- ---- ----------- ---- ---- ---- ---- -----
DEF$_AQCALL          0    0                    0   57   1099541169257   1099541169257 30.03.00   41 9.52.466                                 0              0   930
DEF$_AQCALL          0    0                    0   29   1099541169259   1099541169259 30.03.00   41 10.77.356                                0              0   916
DEF$_AQCALL          0    0                    0   29   1099541187578   1099541187578 03.04.00   41 2.72.400                                 0              0   916
*/

