--  -:

-- A.  REPADMIN   ;
--      REPADMIN (  - ?)

-- B.  scheduling purge  REPADMIN

-- C.   SKUUFA3  REPADMIN

set echo on
spool CMSKURG.LST

connect SYSTEM/admkurg@SKU_KURG.WORLD

-- 1. Creating user 'REPADMIN' at site 'UFA3' (-  CUser.sql  . )
-- create user REPADMIN identified by ADMINREP;

-- 2. Granting admin privileges to user 'REPADMIN' at site 'UFA3'
begin
	dbms_repcat_admin.grant_admin_any_schema(
	username => 'REPADMIN');
end;
/
grant comment any table to REPADMIN;
grant lock any table to REPADMIN;

-- 3. Registering user 'REPADMIN' as propagator at site 'UFA3'
begin
   dbms_defer_sys.register_propagator(username => 'REPADMIN');
end;
/

-- 4. Granting privileges to user 'REPADMIN'
grant execute any procedure to REPADMIN;

-----------------------------------------------------------------------------

-- 5. Connection to: REPADMIN
connect REPADMIN/adminrep@SKU_KURG.WORLD

-- Scheduling purge at site 'UFA3'
begin
   dbms_defer_sys.schedule_purge(
    next_date => sysdate,
    interval => '/*1:Day*/ sysdate + 1',
    delay_seconds => 0,
    rollback_segment => 'R10');
end;
/

-- 6. Creating scheduled link 'UFA3'.
begin
   dbms_defer_sys.schedule_push(
      destination => 'UFA3.WORLD',
      next_date => sysdate,
      interval => '/*10:Mins*/ sysdate + 10/(60*24)',
      stop_on_error => FALSE,
      delay_seconds => 0,
      parallelism => 0);
end;
/

-----------------------------------------------------------------------------

-- Connection to: SYSTEM@
connect SYSTEM/admKURG@SKU_KURG.WORLD

-- 7. Granting privileges to user 'SKUUFA3'
grant alter session to SKUUFA3;		-- ( CONNECT)
grant create cluster to SKUUFA3;	-- ( CONNECT, RESOURCE)
grant create database link to SKUUFA3;	-- ( CONNECT)
grant create sequence to SKUUFA3;	-- ( CONNECT, RESOURCE)
grant create session to SKUUFA3;	-- ( CONNECT)
grant create synonym to SKUUFA3;	-- ( CONNECT)
grant create table to SKUUFA3;		-- ( CONNECT, RESOURCE)
grant create view to SKUUFA3;		-- ( CONNECT)
grant create procedure to SKUUFA3;	-- ( RESOURCE)
grant create trigger to SKUUFA3;	-- ( RESOURCE)
grant unlimited tablespace to SKUUFA3;  -- (  ..)
grant create type to  SKUUFA3;		-- ( RESOURCE)
grant create any snapshot to SKUUFA3;	-- (  ..)
grant alter any snapshot to SKUUFA3;	-- (  ..)

-- 8.    -  REPADMIN (  )
grant CONNECT, RESOURCE to REPADMIN;
grant unlimited tablespace to REPADMIN;
grant create any snapshot to REPADMIN;
grant alter any snapshot to REPADMIN;

rem , ,  :
-- grant SELECT_CATALOG_ROLE to REPADMIN;
-- grant insert any table to REPADMIN;
-- grant select any table to REPADMIN;
-- grant update any table to REPADMIN;
rem ... ( )
-- grant select on SYSTEM.DEF$_LOB to REPADMIN;
-- grant select on SYS.DEFLOB to REPADMIN;
-- grant execute on SYS.DBMS_DEFER_SYS to REPADMIN;
-- grant execute on SYS.DBMS_SNAPSHOT to REPADMIN;
-- grant execute on SYS.DBMS_SNAP_REPAPI to REPADMIN;
-- grant execute on SYS.DBMS_DEFER_QUERY to REPADMIN;
-- grant execute on SYS.DBMS_DEFER_INTERNAL to REPADMIN;
-- grant execute on SYS.DBMS_REPCAT_DECL to REPADMIN;
-- grant execute on SYS.DBMS_REPCAT_UNTRUST to REPADMIN;
-- grant execute on SYS.DBMS_REPCAT_RPC to REPADMIN;
-- grant execute on SYS.DBMS_REPCAT_UTL2 to REPADMIN;
-- rem grant execute on SYS.DBMS_REPCAT_RECTIFIER_DIFF.. to REPADMIN;
-- grant execute on SYS.DBMS_OBJGWRAPPER to REPADMIN;

rem    ,  
-- grant DBA to REPADMIN;

spool off
