PROMPT DFEA_KEY;
CREATE OR REPLACE FUNCTION DFEA_KEY(NADM IN NUMBER) RETURN NUMBER IS
NPHY NUMBER(12);
BEGIN
SELECT DFEA_SEQ.NEXTVAL INTO NPHY FROM DUAL;
RETURN NPHY;
EXCEPTION
WHEN NO_DATA_FOUND THEN
RETURN NULL;
END DFEA_KEY;
/
PROMPT DFEA_INSERT;
CREATE OR REPLACE TRIGGER DFEA_INSERT
BEFORE INSERT OR UPDATE ON DFEA
FOR EACH ROW
BEGIN
IF INSERTING AND (NVL(:NEW.SYSKEY,0)=0) THEN
    :NEW.SYSKEY:=DFEA_KEY(0);
END IF;
:NEW.DATELAST:=SYSDATE;
:NEW.USERLAST:=USER;
END;
/
PROMPT DFEA_FIX;
CREATE OR REPLACE TRIGGER DFEA_FIX
AFTER INSERT OR UPDATE OR DELETE ON DFEA
FOR EACH ROW
DECLARE
N number(3);
K number(12);
BEGIN
IF INSERTING THEN
  N:=1;
ELSIF UPDATING THEN
  N:=2;
ELSE
  N:=3;
  K:=:OLD.SYSKEY;
END IF;
IF N<>3 THEN
  K:=:NEW.SYSKEY;
END IF;
INSERT INTO ALLEDITIONS (TBNAME,TBKEY,ACTION) VALUES ('DFEA',K,N);
END;
/
