/*
SQL> desc dba_jobs
                              .?  
 ------------------------------- -------- ----
 JOB                             NOT NULL NUMBER
 LOG_USER                        NOT NULL VARCHAR2(30)
 PRIV_USER                       NOT NULL VARCHAR2(30)
 SCHEMA_USER                     NOT NULL VARCHAR2(30)
 LAST_DATE                                DATE
 LAST_SEC                                 VARCHAR2(8)
 THIS_DATE                                DATE
 THIS_SEC                                 VARCHAR2(8)
 NEXT_DATE                       NOT NULL DATE
 NEXT_SEC                                 VARCHAR2(8)
 TOTAL_TIME                               NUMBER
 BROKEN                                   VARCHAR2(1)
 INTERVAL                        NOT NULL VARCHAR2(200)
 FAILURES                                 NUMBER
 WHAT                                     VARCHAR2(4000)
 CURRENT_SESSION_LABEL                    MLSLABEL
 CLEARANCE_HI                             MLSLABEL
 CLEARANCE_LO                             MLSLABEL
 NLS_ENV                                  VARCHAR2(4000)
 MISC_ENV                                 RAW(32)
*/


select
  JOB, substr(WHAT,40,25) WH,
  substr(LOG_USER,1,3) LU, substr(PRIV_USER,1,3) PU, substr(SCHEMA_USER,1,3) SU,
  LAST_DATE, LAST_SEC,
  THIS_DATE, THIS_SEC,
--NEXT_DATE, NEXT_SEC,
  to_char(TOTAL_TIME,'9999999') TT, BROKEN, to_char(FAILURES,'999') FS,
  substr(INTERVAL,1,33) IL, substr(NLS_ENV,15,10) LAN, substr(NLS_ENV,40,10) TER
from dba_jobs;
/

