" as
  procedure rep_delete(
    "BUCH1_o" IN NUMBER,
    "CNEXT2_o" IN NUMBER,
    "CPEREG3_o" IN NUMBER,
    "CPIPELIN4_o" IN NUMBER,
    "CPRED5_o" IN NUMBER,
    "CTUCH6_o" IN NUMBER,
    "CUCHPROF7_o" IN NUMBER,
    "DATELAST8_o" IN DATE,
    "DESCR9_o" IN VARCHAR2,
    "DUCH10_o" IN NUMBER,
    "KM11_o" IN NUMBER,
    "LM12_o" IN NUMBER,
    "MBEG13_o" IN NUMBER,
    "MEND14_o" IN NUMBER,
    "NL15_o" IN NUMBER,
    "NM16_o" IN NUMBER,
    "NN17_o" IN NUMBER,
    "NT18_o" IN NUMBER,
    "NU19_o" IN NUMBER,
    "PFACT20_o" IN NUMBER,
    "PPROJ21_o" IN NUMBER,
    "SYSKEY22_o" IN NUMBER,
    "USERLAST23_o" IN VARCHAR2,
    "VFACT24_o" IN NUMBER,
    "VPROJ25_o" IN NUMBER,
    site_name IN VARCHAR2,
    propagation_flag IN CHAR) is
  begin
    rep_delete(
      NULL,
      "BUCH1_o",
      "CNEXT2_o",
      "CPEREG3_o",
      "CPIPELIN4_o",
      "CPRED5_o",
      "CTUCH6_o",
      "CUCHPROF7_o",
      "DATELAST8_o",
      "DESCR9_o",
      "DUCH10_o",
      "KM11_o",
      "LM12_o",
      "MBEG13_o",
      "MEND14_o",
      "NL15_o",
      "NM16_o",
      "NN17_o",
      "NT18_o",
      "NU19_o",
      "PFACT20_o",
      "PPROJ21_o",
      "SYSKEY22_o",
      "USERLAST23_o",
      "VFACT24_o",
      "VPROJ25_o",
      site_name,
      propagation_flag);
  end rep_delete;
  procedure rep_delete(
    column_changed$ IN RAW,
    "BUCH1_o" IN NUMBER,
    "CNEXT2_o" IN NUMBER,
    "CPEREG3_o" IN NUMBER,
    "CPIPELIN4_o" IN NUMBER,
    "CPRED5_o" IN NUMBER,
    "CTUCH6_o" IN NUMBER,
    "CUCHPROF7_o" IN NUMBER,
    "DATELAST8_o" IN DATE,
    "DESCR9_o" IN VARCHAR2,
    "DUCH10_o" IN NUMBER,
    "KM11_o" IN NUMBER,
    "LM12_o" IN NUMBER,
    "MBEG13_o" IN NUMBER,
    "MEND14_o" IN NUMBER,
    "NL15_o" IN NUMBER,
    "NM16_o" IN NUMBER,
    "NN17_o" IN NUMBER,
    "NT18_o" IN NUMBER,
    "NU19_o" IN NUMBER,
    "PFACT20_o" IN NUMBER,
    "PPROJ21_o" IN NUMBER,
    "SYSKEY22_o" IN NUMBER,
    "USERLAST23_o" IN VARCHAR2,
    "VFACT24_o" IN NUMBER,
    "VPROJ25_o" IN NUMBER,
    site_name IN VARCHAR2,
    propagation_flag IN CHAR) is
    column_sent$_varchar2 VARCHAR2(25);
  begin
    column_changed$$ := column_changed$;
    if column_changed$ is not null then
      dbms_reputil.raw_to_varchar2(column_changed$,
                                   2,
                                   column_sent$_varchar2);
    end if;
    if propagation_flag = 'N' then
      dbms_reputil.replication_off;
    end if;
    dbms_reputil.rep_begin(site_name);
    dbms_reputil.global_name := site_name;
    delete from "UCHASTOK"
    where (
            decode(substr(column_sent$_varchar2, 1, 1),
                   'N', 'Y',
                   decode("BUCH1_o", "BUCH", 'Y', 'N')) = 'Y'
    and   
            decode(substr(column_sent$_varchar2, 2, 1),
                   'N', 'Y',
                   decode("CNEXT2_o", "CNEXT", 'Y', 'N')) = 'Y'
    and   
            decode(substr(column_sent$_varchar2, 3, 1),
                   'N', 'Y',
                   decode("CPEREG3_o", "CPEREG", 'Y', 'N')) = 'Y'
    and   
            decode(substr(column_sent$_varchar2, 4, 1),
                   'N', 'Y',
                   decode("CPIPELIN4_o", "CPIPELIN", 'Y', 'N')) = 'Y'
    and   
            decode(substr(column_sent$_varchar2, 5, 1),
                   'N', 'Y',
                   decode("CPRED5_o", "CPRED", 'Y', 'N')) = 'Y'
    and   
            decode(substr(column_sent$_varchar2, 6, 1),
                   'N', 'Y',
                   decode("CTUCH6_o", "CTUCH", 'Y', 'N')) = 'Y'
    and   
            decode(substr(column_sent$_varchar2, 7, 1),
                   'N', 'Y',
                   decode("CUCHPROF7_o", "CUCHPROF", 'Y', 'N')) = 'Y'
    and   
            decode(substr(column_sent$_varchar2, 8, 1),
                   'N', 'Y',
                   decode("DATELAST8_o", "DATELAST", 'Y', 'N')) = 'Y'
    and   
            decode(substr(column_sent$_varchar2, 9, 1),
                   'N', 'Y',
                   decode("DESCR9_o", "DESCR", 'Y', 'N')) = 'Y'
    and   
            decode(substr(column_sent$_varchar2, 10, 1),
                   'N', 'Y',
                   decode("DUCH10_o", "DUCH", 'Y', 'N')) = 'Y'
          )
    and   (
            decode(substr(column_sent$_varchar2, 11, 1),
                   'N', 'Y',
                   decode("KM11_o", "KM", 'Y', 'N')) = 'Y'
    and   
            decode(substr(column_sent$_varchar2, 12, 1),
                   'N', 'Y',
                   decode("LM12_o", "LM", 'Y', 'N')) = 'Y'
    and   
            decode(substr(column_sent$_varchar2, 13, 1),
                   'N', 'Y',
                   decode("MBEG13_o", "MBEG", 'Y', 'N')) = 'Y'
    and   
            decode(substr(column_sent$_varchar2, 14, 1),
                   'N', 'Y',
                   decode("MEND14_o", "MEND", 'Y', 'N')) = 'Y'
    and   
            decode(substr(column_sent$_varchar2, 15, 1),
                   'N', 'Y',
                   decode("NL15_o", "NL", 'Y', 'N')) = 'Y'
    and   
            decode(substr(column_sent$_varchar2, 16, 1),
                   'N', 'Y',
                   decode("NM16_o", "NM", 'Y', 'N')) = 'Y'
    and   
            decode(substr(column_sent$_varchar2, 17, 1),
                   'N', 'Y',
                   decode("NN17_o", "NN", 'Y', 'N')) = 'Y'
    and   
            decode(substr(column_sent$_varchar2, 18, 1),
                   'N', 'Y',
                   decode("NT18_o", "NT", 'Y', 'N')) = 'Y'
    and   
            decode(substr(column_sent$_varchar2, 19, 1),
                   'N', 'Y',
                   decode("NU19_o", "NU", 'Y', 'N')) = 'Y'
    and   
            decode(substr(column_sent$_varchar2, 20, 1),
                   'N', 'Y',
                   decode("PFACT20_o", "PFACT", 'Y', 'N')) = 'Y'
          )
    and   (
            decode(substr(column_sent$_varchar2, 21, 1),
                   'N', 'Y',
                   decode("PPROJ21_o", "PPROJ", 'Y', 'N')) = 'Y'
    and   
            "SYSKEY22_o" = "SYSKEY"
    and   
            decode(substr(column_sent$_varchar2, 23, 1),
                   'N', 'Y',
                   decode("USERLAST23_o", "USERLAST", 'Y', 'N')) = 'Y'
    and   
            decode(substr(column_sent$_varchar2, 24, 1),
                   'N', 'Y',
                   decode("VFACT24_o", "VFACT", 'Y', 'N')) = 'Y'
    and   
            decode(substr(column_sent$_varchar2, 25, 1),
                   'N', 'Y',
                   decode("VPROJ25_o", "VPROJ", 'Y', 'N')) = 'Y'
          );
    if sql%rowcount = 0 then
      raise no_data_found;
    elsif sql%rowcount > 1 then
      raise too_many_rows;
    end if;
    dbms_reputil.rep_end;
  exception
    when no_data_found then
      begin
        if not "UCHASTOK$RR".delete_conflict_handler(
          "BUCH1_o",
          "CNEXT2_o",
          "CPEREG3_o",
          "CPIPELIN4_o",
          "CPRED5_o",
          "CTUCH6_o",
          "CUCHPROF7_o",
          "DATELAST8_o",
          "DESCR9_o",
          "DUCH10_o",
          "KM11_o",
          "LM12_o",
          "MBEG13_o",
          "MEND14_o",
          "NL15_o",
          "NM16_o",
          "NN17_o",
          "NT18_o",
          "NU19_o",
          "PFACT20_o",
          "PPROJ21_o",
          "SYSKEY22_o",
          "USERLAST23_o",
          "VFACT24_o",
          "VPROJ25_o",
          site_name,
          propagation_flag,
          column_changed$,
          column_sent$_varchar2) then
          dbms_reputil.rep_end;
          raise;
        end if;
        dbms_reputil.rep_end;
      exception
        when others then
          dbms_reputil.rep_end;
          raise;
      end;
    when others then
      dbms_reputil.rep_end;
      raise;
  end rep_delete;
  procedure rep_insert(
    "BUCH1_n" IN NUMBER,
    "CNEXT2_n" IN NUMBER,
    "CPEREG3_n" IN NUMBER,
    "CPIPELIN4_n" IN NUMBER,
    "CPRED5_n" IN NUMBER,
    "CTUCH6_n" IN NUMBER,
    "CUCHPROF7_n" IN NUMBER,
    "DATELAST8_n" IN DATE,
    "DESCR9_n" IN VARCHAR2,
    "DUCH10_n" IN NUMBER,
    "KM11_n" IN NUMBER,
    "LM12_n" IN NUMBER,
    "MBEG13_n" IN NUMBER,
    "MEND14_n" IN NUMBER,
    "NL15_n" IN NUMBER,
    "NM16_n" IN NUMBER,
    "NN17_n" IN NUMBER,
    "NT18_n" IN NUMBER,
    "NU19_n" IN NUMBER,
    "PFACT20_n" IN NUMBER,
    "PPROJ21_n" IN NUMBER,
    "SYSKEY22_n" IN NUMBER,
    "USERLAST23_n" IN VARCHAR2,
    "VFACT24_n" IN NUMBER,
    "VPROJ25_n" IN NUMBER,
    site_name IN VARCHAR2,
    propagation_flag IN CHAR) is
  begin
    if propagation_flag = 'N' then
      dbms_reputil.replication_off;
    end if;
    dbms_reputil.rep_begin(site_name);
    dbms_reputil.global_name := site_name;
    insert into "UCHASTOK" (
      "BUCH",
      "CNEXT",
      "CPEREG",
      "CPIPELIN",
      "CPRED",
      "CTUCH",
      "CUCHPROF",
      "DATELAST",
      "DESCR",
      "DUCH",
      "KM",
      "LM",
      "MBEG",
      "MEND",
      "NL",
      "NM",
      "NN",
      "NT",
      "NU",
      "PFACT",
      "PPROJ",
      "SYSKEY",
      "USERLAST",
      "VFACT",
      "VPROJ")
    values (
      "BUCH1_n",
      "CNEXT2_n",
      "CPEREG3_n",
      "CPIPELIN4_n",
      "CPRED5_n",
      "CTUCH6_n",
      "CUCHPROF7_n",
      "DATELAST8_n",
      "DESCR9_n",
      "DUCH10_n",
      "KM11_n",
      "LM12_n",
      "MBEG13_n",
      "MEND14_n",
      "NL15_n",
      "NM16_n",
      "NN17_n",
      "NT18_n",
      "NU19_n",
      "PFACT20_n",
      "PPROJ21_n",
      "SYSKEY22_n",
      "USERLAST23_n",
      "VFACT24_n",
      "VPROJ25_n");
    dbms_reputil.rep_end;
  exception
    when dup_val_on_index then
      begin
        if not "UCHASTOK$RR".unique_conflict_insert_handler(
          "BUCH1_n",
          "CNEXT2_n",
          "CPEREG3_n",
          "CPIPELIN4_n",
          "CPRED5_n",
          "CTUCH6_n",
          "CUCHPROF7_n",
          "DATELAST8_n",
          "DESCR9_n",
          "DUCH10_n",
          "KM11_n",
          "LM12_n",
          "MBEG13_n",
          "MEND14_n",
          "NL15_n",
          "NM16_n",
          "NN17_n",
          "NT18_n",
          "NU19_n",
          "PFACT20_n",
          "PPROJ21_n",
          "SYSKEY22_n",
          "USERLAST23_n",
          "VFACT24_n",
          "VPROJ25_n",
          site_name,
          propagation_flag,
          SQLERRM) then
          dbms_reputil.rep_end;
          raise;
        end if;
        dbms_reputil.rep_end;
      exception
        when others then
          dbms_reputil.rep_end;
          raise;
      end;
    when others then
      dbms_reputil.rep_end;
      raise;
  end rep_insert;
  procedure rep_update(
    "BUCH1_o" IN NUMBER,
    "BUCH1_n" IN NUMBER,
    "CNEXT2_o" IN NUMBER,
    "CNEXT2_n" IN NUMBER,
    "CPEREG3_o" IN NUMBER,
    "CPEREG3_n" IN NUMBER,
    "CPIPELIN4_o" IN NUMBER,
    "CPIPELIN4_n" IN NUMBER,
    "CPRED5_o" IN NUMBER,
    "CPRED5_n" IN NUMBER,
    "CTUCH6_o" IN NUMBER,
    "CTUCH6_n" IN NUMBER,
    "CUCHPROF7_o" IN NUMBER,
    "CUCHPROF7_n" IN NUMBER,
    "DATELAST8_o" IN DATE,
    "DATELAST8_n" IN DATE,
    "DESCR9_o" IN VARCHAR2,
    "DESCR9_n" IN VARCHAR2,
    "DUCH10_o" IN NUMBER,
    "DUCH10_n" IN NUMBER,
    "KM11_o" IN NUMBER,
    "KM11_n" IN NUMBER,
    "LM12_o" IN NUMBER,
    "LM12_n" IN NUMBER,
    "MBEG13_o" IN NUMBER,
    "MBEG13_n" IN NUMBER,
    "MEND14_o" IN NUMBER,
    "MEND14_n" IN NUMBER,
    "NL15_o" IN NUMBER,
    "NL15_n" IN NUMBER,
    "NM16_o" IN NUMBER,
    "NM16_n" IN NUMBER,
    "NN17_o" IN NUMBER,
    "NN17_n" IN NUMBER,
    "NT18_o" IN NUMBER,
    "NT18_n" IN NUMBER,
    "NU19_o" IN NUMBER,
    "NU19_n" IN NUMBER,
    "PFACT20_o" IN NUMBER,
    "PFACT20_n" IN NUMBER,
    "PPROJ21_o" IN NUMBER,
    "PPROJ21_n" IN NUMBER,
    "SYSKEY22_o" IN NUMBER,
    "SYSKEY22_n" IN NUMBER,
    "USERLAST23_o" IN VARCHAR2,
    "USERLAST23_n" IN VARCHAR2,
    "VFACT24_o" IN NUMBER,
    "VFACT24_n" IN NUMBER,
    "VPROJ25_o" IN NUMBER,
    "VPROJ25_n" IN NUMBER,
    site_name IN VARCHAR2,
    propagation_flag IN CHAR) is
  begin
    rep_update(
      NULL,
      "BUCH1_o",
      "BUCH1_n",
      "CNEXT2_o",
      "CNEXT2_n",
      "CPEREG3_o",
      "CPEREG3_n",
      "CPIPELIN4_o",
      "CPIPELIN4_n",
      "CPRED5_o",
      "CPRED5_n",
      "CTUCH6_o",
      "CTUCH6_n",
      "CUCHPROF7_o",
      "CUCHPROF7_n",
      "DATELAST8_o",
      "DATELAST8_n",
      "DESCR9_o",
      "DESCR9_n",
      "DUCH10_o",
      "DUCH10_n",
      "KM11_o",
      "KM11_n",
      "LM12_o",
      "LM12_n",
      "MBEG13_o",
      "MBEG13_n",
      "MEND14_o",
      "MEND14_n",
      "NL15_o",
      "NL15_n",
      "NM16_o",
      "NM16_n",
      "NN17_o",
      "NN17_n",
      "NT18_o",
      "NT18_n",
      "NU19_o",
      "NU19_n",
      "PFACT20_o",
      "PFACT20_n",
      "PPROJ21_o",
      "PPROJ21_n",
      "SYSKEY22_o",
      "SYSKEY22_n",
      "USERLAST23_o",
      "USERLAST23_n",
      "VFACT24_o",
      "VFACT24_n",
      "VPROJ25_o",
      "VPROJ25_n",
      site_name,
      propagation_flag);
  end rep_update;
  procedure rep_update(
    column_changed$ IN RAW,
    "BUCH1_o" IN NUMBER,
    "BUCH1_n" IN NUMBER,
    "CNEXT2_o" IN NUMBER,
    "CNEXT2_n" IN NUMBER,
    "CPEREG3_o" IN NUMBER,
    "CPEREG3_n" IN NUMBER,
    "CPIPELIN4_o" IN NUMBER,
    "CPIPELIN4_n" IN NUMBER,
    "CPRED5_o" IN NUMBER,
    "CPRED5_n" IN NUMBER,
    "CTUCH6_o" IN NUMBER,
    "CTUCH6_n" IN NUMBER,
    "CUCHPROF7_o" IN NUMBER,
    "CUCHPROF7_n" IN NUMBER,
    "DATELAST8_o" IN DATE,
    "DATELAST8_n" IN DATE,
    "DESCR9_o" IN VARCHAR2,
    "DESCR9_n" IN VARCHAR2,
    "DUCH10_o" IN NUMBER,
    "DUCH10_n" IN NUMBER,
    "KM11_o" IN NUMBER,
    "KM11_n" IN NUMBER,
    "LM12_o" IN NUMBER,
    "LM12_n" IN NUMBER,
    "MBEG13_o" IN NUMBER,
    "MBEG13_n" IN NUMBER,
    "MEND14_o" IN NUMBER,
    "MEND14_n" IN NUMBER,
    "NL15_o" IN NUMBER,
    "NL15_n" IN NUMBER,
    "NM16_o" IN NUMBER,
    "NM16_n" IN NUMBER,
    "NN17_o" IN NUMBER,
    "NN17_n" IN NUMBER,
    "NT18_o" IN NUMBER,
    "NT18_n" IN NUMBER,
    "NU19_o" IN NUMBER,
    "NU19_n" IN NUMBER,
    "PFACT20_o" IN NUMBER,
    "PFACT20_n" IN NUMBER,
    "PPROJ21_o" IN NUMBER,
    "PPROJ21_n" IN NUMBER,
    "SYSKEY22_o" IN NUMBER,
    "SYSKEY22_n" IN NUMBER,
    "USERLAST23_o" IN VARCHAR2,
    "USERLAST23_n" IN VARCHAR2,
    "VFACT24_o" IN NUMBER,
    "VFACT24_n" IN NUMBER,
    "VPROJ25_o" IN NUMBER,
    "VPROJ25_n" IN NUMBER,
    site_name IN VARCHAR2,
    propagation_flag IN CHAR) is
    column_changed$_varchar2 VARCHAR2(25);
    column_sent$_varchar2 VARCHAR2(25);
  begin
    column_changed$$ := column_changed$;
    if column_changed$ is not null then
      dbms_reputil.raw_to_varchar2(column_changed$,
                                   1,
                                   column_changed$_varchar2);
      dbms_reputil.raw_to_varchar2(column_changed$,
                                   2,
                                   column_sent$_varchar2);
    end if;
    if propagation_flag = 'N' then
      dbms_reputil.replication_off;
    end if;
    dbms_reputil.rep_begin(site_name);
    dbms_reputil.global_name := site_name;
    update "UCHASTOK" set
      "BUCH" =
        decode(substr(column_changed$_varchar2, 1, 1),
            'N', "BUCH",
            'Y', "BUCH1_n",
            NULL, decode("BUCH1_o",
                         "BUCH1_n","BUCH",
                         "BUCH1_n")),
      "CNEXT" =
        decode(substr(column_changed$_varchar2, 2, 1),
            'N', "CNEXT",
            'Y', "CNEXT2_n",
            NULL, decode("CNEXT2_o",
                         "CNEXT2_n","CNEXT",
                         "CNEXT2_n")),
      "CPEREG" =
        decode(substr(column_changed$_varchar2, 3, 1),
            'N', "CPEREG",
            'Y', "CPEREG3_n",
            NULL, decode("CPEREG3_o",
                         "CPEREG3_n","CPEREG",
                         "CPEREG3_n")),
      "CPIPELIN" =
        decode(substr(column_changed$_varchar2, 4, 1),
            'N', "CPIPELIN",
            'Y', "CPIPELIN4_n",
            NULL, decode("CPIPELIN4_o",
                         "CPIPELIN4_n","CPIPELIN",
                         "CPIPELIN4_n")),
      "CPRED" =
        decode(substr(column_changed$_varchar2, 5, 1),
            'N', "CPRED",
            'Y', "CPRED5_n",
            NULL, decode("CPRED5_o",
                         "CPRED5_n","CPRED",
                         "CPRED5_n")),
      "CTUCH" =
        decode(substr(column_changed$_varchar2, 6, 1),
            'N', "CTUCH",
            'Y', "CTUCH6_n",
            NULL, decode("CTUCH6_o",
                         "CTUCH6_n","CTUCH",
                         "CTUCH6_n")),
      "CUCHPROF" =
        decode(substr(column_changed$_varchar2, 7, 1),
            'N', "CUCHPROF",
            'Y', "CUCHPROF7_n",
            NULL, decode("CUCHPROF7_o",
                         "CUCHPROF7_n","CUCHPROF",
                         "CUCHPROF7_n")),
      "DATELAST" =
        decode(substr(column_changed$_varchar2, 8, 1),
            'N', "DATELAST",
            'Y', "DATELAST8_n",
            NULL, decode("DATELAST8_o",
                         "DATELAST8_n","DATELAST",
                         "DATELAST8_n")),
      "DESCR" =
        decode(substr(column_changed$_varchar2, 9, 1),
            'N', "DESCR",
            'Y', "DESCR9_n",
            NULL, decode("DESCR9_o",
                         "DESCR9_n","DESCR",
                         "DESCR9_n")),
      "DUCH" =
        decode(substr(column_changed$_varchar2, 10, 1),
            'N', "DUCH",
            'Y', "DUCH10_n",
            NULL, decode("DUCH10_o",
                         "DUCH10_n","DUCH",
                         "DUCH10_n")),
      "KM" =
        decode(substr(column_changed$_varchar2, 11, 1),
            'N', "KM",
            'Y', "KM11_n",
            NULL, decode("KM11_o",
                         "KM11_n","KM",
                         "KM11_n")),
      "LM" =
        decode(substr(column_changed$_varchar2, 12, 1),
            'N', "LM",
            'Y', "LM12_n",
            NULL, decode("LM12_o",
                         "LM12_n","LM",
                         "LM12_n")),
      "MBEG" =
        decode(substr(column_changed$_varchar2, 13, 1),
            'N', "MBEG",
            'Y', "MBEG13_n",
            NULL, decode("MBEG13_o",
                         "MBEG13_n","MBEG",
                         "MBEG13_n")),
      "MEND" =
        decode(substr(column_changed$_varchar2, 14, 1),
            'N', "MEND",
            'Y', "MEND14_n",
            NULL, decode("MEND14_o",
                         "MEND14_n","MEND",
                         "MEND14_n")),
      "NL" =
        decode(substr(column_changed$_varchar2, 15, 1),
            'N', "NL",
            'Y', "NL15_n",
            NULL, decode("NL15_o",
                         "NL15_n","NL",
                         "NL15_n")),
      "NM" =
        decode(substr(column_changed$_varchar2, 16, 1),
            'N', "NM",
            'Y', "NM16_n",
            NULL, decode("NM16_o",
                         "NM16_n","NM",
                         "NM16_n")),
      "NN" =
        decode(substr(column_changed$_varchar2, 17, 1),
            'N', "NN",
            'Y', "NN17_n",
            NULL, decode("NN17_o",
                         "NN17_n","NN",
                         "NN17_n")),
      "NT" =
        decode(substr(column_changed$_varchar2, 18, 1),
            'N', "NT",
            'Y', "NT18_n",
            NULL, decode("NT18_o",
                         "NT18_n","NT",
                         "NT18_n")),
      "NU" =
        decode(substr(column_changed$_varchar2, 19, 1),
            'N', "NU",
            'Y', "NU19_n",
            NULL, decode("NU19_o",
                         "NU19_n","NU",
                         "NU19_n")),
      "PFACT" =
        decode(substr(column_changed$_varchar2, 20, 1),
            'N', "PFACT",
            'Y', "PFACT20_n",
            NULL, decode("PFACT20_o",
                         "PFACT20_n","PFACT",
                         "PFACT20_n")),
      "PPROJ" =
        decode(substr(column_changed$_varchar2, 21, 1),
            'N', "PPROJ",
            'Y', "PPROJ21_n",
            NULL, decode("PPROJ21_o",
                         "PPROJ21_n","PPROJ",
                         "PPROJ21_n")),
      "SYSKEY" =
        decode(substr(column_changed$_varchar2, 22, 1),
            'N', "SYSKEY",
            'Y', "SYSKEY22_n",
            NULL, decode("SYSKEY22_o",
                         "SYSKEY22_n","SYSKEY",
                         "SYSKEY22_n")),
      "USERLAST" =
        decode(substr(column_changed$_varchar2, 23, 1),
            'N', "USERLAST",
            'Y', "USERLAST23_n",
            NULL, decode("USERLAST23_o",
                         "USERLAST23_n","USERLAST",
                         "USERLAST23_n")),
      "VFACT" =
        decode(substr(column_changed$_varchar2, 24, 1),
            'N', "VFACT",
            'Y', "VFACT24_n",
            NULL, decode("VFACT24_o",
                         "VFACT24_n","VFACT",
                         "VFACT24_n")),
      "VPROJ" =
        decode(substr(column_changed$_varchar2, 25, 1),
            'N', "VPROJ",
            'Y', "VPROJ25_n",
            NULL, decode("VPROJ25_o",
                         "VPROJ25_n","VPROJ",
                         "VPROJ25_n"))
    where (((decode(substr(column_changed$_varchar2, 1, 1),
                     'N', 'Y',
                     'Y', 'N',
                     decode("BUCH1_o", "BUCH1_n", 'Y', 'N')) = 'Y' and
             decode(substr(column_changed$_varchar2, 2, 1),
                     'N', 'Y',
                     'Y', 'N',
                     decode("CNEXT2_o", "CNEXT2_n", 'Y', 'N')) = 'Y' and
             decode(substr(column_changed$_varchar2, 3, 1),
                     'N', 'Y',
                     'Y', 'N',
                     decode("CPEREG3_o", "CPEREG3_n", 'Y', 'N')) = 'Y' and
             decode(substr(column_changed$_varchar2, 4, 1),
                     'N', 'Y',
                     'Y', 'N',
                     decode("CPIPELIN4_o", "CPIPELIN4_n", 'Y', 'N')) = 'Y' and
             decode(substr(column_changed$_varchar2, 5, 1),
                     'N', 'Y',
                     'Y', 'N',
                     decode("CPRED5_o", "CPRED5_n", 'Y', 'N')) = 'Y' and
             decode(substr(column_changed$_varchar2, 6, 1),
                     'N', 'Y',
                     'Y', 'N',
                     decode("CTUCH6_o", "CTUCH6_n", 'Y', 'N')) = 'Y' and
             decode(substr(column_changed$_varchar2, 7, 1),
                     'N', 'Y',
                     'Y', 'N',
                     decode("CUCHPROF7_o", "CUCHPROF7_n", 'Y', 'N')) = 'Y' and
             decode(substr(column_changed$_varchar2, 8, 1),
                     'N', 'Y',
                     'Y', 'N',
                     decode("DATELAST8_o", "DATELAST8_n", 'Y', 'N')) = 'Y' and
             decode(substr(column_changed$_varchar2, 9, 1),
                     'N', 'Y',
                     'Y', 'N',
                     decode("DESCR9_o", "DESCR9_n", 'Y', 'N')) = 'Y' and
             decode(substr(column_changed$_varchar2, 10, 1),
                     'N', 'Y',
                     'Y', 'N',
                     decode("DUCH10_o", "DUCH10_n", 'Y', 'N')) = 'Y') and (
             decode(substr(column_changed$_varchar2, 11, 1),
                     'N', 'Y',
                     'Y', 'N',
                     decode("KM11_o", "KM11_n", 'Y', 'N')) = 'Y' and
             decode(substr(column_changed$_varchar2, 12, 1),
                     'N', 'Y',
                     'Y', 'N',
                     decode("LM12_o", "LM12_n", 'Y', 'N')) = 'Y' and
             decode(substr(column_changed$_varchar2, 13, 1),
                     'N', 'Y',
                     'Y', 'N',
                     decode("MBEG13_o", "MBEG13_n", 'Y', 'N')) = 'Y' and
             decode(substr(column_changed$_varchar2, 14, 1),
                     'N', 'Y',
                     'Y', 'N',
                     decode("MEND14_o", "MEND14_n", 'Y', 'N')) = 'Y' and
             decode(substr(column_changed$_varchar2, 15, 1),
                     'N', 'Y',
                     'Y', 'N',
                     decode("NL15_o", "NL15_n", 'Y', 'N')) = 'Y' and
             decode(substr(column_changed$_varchar2, 16, 1),
                     'N', 'Y',
                     'Y', 'N',
                     decode("NM16_o", "NM16_n", 'Y', 'N')) = 'Y' and
             decode(substr(column_changed$_varchar2, 17, 1),
                     'N', 'Y',
                     'Y', 'N',
                     decode("NN17_o", "NN17_n", 'Y', 'N')) = 'Y' and
             decode(substr(column_changed$_varchar2, 18, 1),
                     'N', 'Y',
                     'Y', 'N',
                     decode("NT18_o", "NT18_n", 'Y', 'N')) = 'Y' and
             decode(substr(column_changed$_varchar2, 19, 1),
                     'N', 'Y',
                     'Y', 'N',
                     decode("NU19_o", "NU19_n", 'Y', 'N')) = 'Y' and
             decode(substr(column_changed$_varchar2, 20, 1),
                     'N', 'Y',
                     'Y', 'N',
                     decode("PFACT20_o", "PFACT20_n", 'Y', 'N')) = 'Y') and (
             decode(substr(column_changed$_varchar2, 21, 1),
                     'N', 'Y',
                     'Y', 'N',
                     decode("PPROJ21_o", "PPROJ21_n", 'Y', 'N')) = 'Y' and
             1 = 1 and
             decode(substr(column_changed$_varchar2, 23, 1),
                     'N', 'Y',
                     'Y', 'N',
                     decode("USERLAST23_o", "USERLAST23_n", 'Y', 'N')) = 'Y' and
             decode(substr(column_changed$_varchar2, 24, 1),
                     'N', 'Y',
                     'Y', 'N',
                     decode("VFACT24_o", "VFACT24_n", 'Y', 'N')) = 'Y' and
             decode(substr(column_changed$_varchar2, 25, 1),
                     'N', 'Y',
                     'Y', 'N',
                     decode("VPROJ25_o", "VPROJ25_n", 'Y', 'N')) = 'Y')) or
           (decode(substr(column_sent$_varchar2, 1, 1),
                   'N', 'Y',
                   decode("BUCH1_o", "BUCH", 'Y', 'N')) = 'Y' and
            decode(substr(column_sent$_varchar2, 2, 1),
                   'N', 'Y',
                   decode("CNEXT2_o", "CNEXT", 'Y', 'N')) = 'Y' and
            decode(substr(column_sent$_varchar2, 3, 1),
                   'N', 'Y',
                   decode("CPEREG3_o", "CPEREG", 'Y', 'N')) = 'Y' and
            decode(substr(column_sent$_varchar2, 4, 1),
                   'N', 'Y',
                   decode("CPIPELIN4_o", "CPIPELIN", 'Y', 'N')) = 'Y' and
            decode(substr(column_sent$_varchar2, 5, 1),
                   'N', 'Y',
                   decode("CPRED5_o", "CPRED", 'Y', 'N')) = 'Y' and
            decode(substr(column_sent$_varchar2, 6, 1),
                   'N', 'Y',
                   decode("CTUCH6_o", "CTUCH", 'Y', 'N')) = 'Y' and
            decode(substr(column_sent$_varchar2, 7, 1),
                   'N', 'Y',
                   decode("CUCHPROF7_o", "CUCHPROF", 'Y', 'N')) = 'Y' and
            decode(substr(column_sent$_varchar2, 8, 1),
                   'N', 'Y',
                   decode("DATELAST8_o", "DATELAST", 'Y', 'N')) = 'Y' and
            decode(substr(column_sent$_varchar2, 9, 1),
                   'N', 'Y',
                   decode("DESCR9_o", "DESCR", 'Y', 'N')) = 'Y' and
            decode(substr(column_sent$_varchar2, 10, 1),
                   'N', 'Y',
                   decode("DUCH10_o", "DUCH", 'Y', 'N')) = 'Y') and (
            decode(substr(column_sent$_varchar2, 11, 1),
                   'N', 'Y',
                   decode("KM11_o", "KM", 'Y', 'N')) = 'Y' and
            decode(substr(column_sent$_varchar2, 12, 1),
                   'N', 'Y',
                   decode("LM12_o", "LM", 'Y', 'N')) = 'Y' and
            decode(substr(column_sent$_varchar2, 13, 1),
                   'N', 'Y',
                   decode("MBEG13_o", "MBEG", 'Y', 'N')) = 'Y' and
            decode(substr(column_sent$_varchar2, 14, 1),
                   'N', 'Y',
                   decode("MEND14_o", "MEND", 'Y', 'N')) = 'Y' and
            decode(substr(column_sent$_varchar2, 15, 1),
                   'N', 'Y',
                   decode("NL15_o", "NL", 'Y', 'N')) = 'Y' and
            decode(substr(column_sent$_varchar2, 16, 1),
                   'N', 'Y',
                   decode("NM16_o", "NM", 'Y', 'N')) = 'Y' and
            decode(substr(column_sent$_varchar2, 17, 1),
                   'N', 'Y',
                   decode("NN17_o", "NN", 'Y', 'N')) = 'Y' and
            decode(substr(column_sent$_varchar2, 18, 1),
                   'N', 'Y',
                   decode("NT18_o", "NT", 'Y', 'N')) = 'Y' and
            decode(substr(column_sent$_varchar2, 19, 1),
                   'N', 'Y',
                   decode("NU19_o", "NU", 'Y', 'N')) = 'Y' and
            decode(substr(column_sent$_varchar2, 20, 1),
                   'N', 'Y',
                   decode("PFACT20_o", "PFACT", 'Y', 'N')) = 'Y') and (
            decode(substr(column_sent$_varchar2, 21, 1),
                   'N', 'Y',
                   decode("PPROJ21_o", "PPROJ", 'Y', 'N')) = 'Y' and
            1 = 1 and
            decode(substr(column_sent$_varchar2, 23, 1),
                   'N', 'Y',
                   decode("USERLAST23_o", "USERLAST", 'Y', 'N')) = 'Y' and
            decode(substr(column_sent$_varchar2, 24, 1),
                   'N', 'Y',
                   decode("VFACT24_o", "VFACT", 'Y', 'N')) = 'Y' and
            decode(substr(column_sent$_varchar2, 25, 1),
                   'N', 'Y',
                   decode("VPROJ25_o", "VPROJ", 'Y', 'N')) = 'Y'))
      and "SYSKEY22_o" = "SYSKEY";
    if sql%rowcount = 0 then
      raise no_data_found;
    elsif sql%rowcount > 1 then
      raise too_many_rows;
    end if;
    dbms_reputil.rep_end;
  exception
    when no_data_found then
      begin
        if not "UCHASTOK$RR".update_conflict_handler(
          "BUCH1_o",
          dbms_reputil2.choose_number(
              "BUCH1_o",
              "BUCH1_n",
              column_changed$_varchar2, 1),
          "CNEXT2_o",
          dbms_reputil2.choose_number(
              "CNEXT2_o",
              "CNEXT2_n",
              column_changed$_varchar2, 2),
          "CPEREG3_o",
          dbms_reputil2.choose_number(
              "CPEREG3_o",
              "CPEREG3_n",
              column_changed$_varchar2, 3),
          "CPIPELIN4_o",
          dbms_reputil2.choose_number(
              "CPIPELIN4_o",
              "CPIPELIN4_n",
              column_changed$_varchar2, 4),
          "CPRED5_o",
          dbms_reputil2.choose_number(
              "CPRED5_o",
              "CPRED5_n",
              column_changed$_varchar2, 5),
          "CTUCH6_o",
          dbms_reputil2.choose_number(
              "CTUCH6_o",
              "CTUCH6_n",
              column_changed$_varchar2, 6),
          "CUCHPROF7_o",
          dbms_reputil2.choose_number(
              "CUCHPROF7_o",
              "CUCHPROF7_n",
              column_changed$_varchar2, 7),
          "DATELAST8_o",
          dbms_reputil2.choose_date(
              "DATELAST8_o",
              "DATELAST8_n",
              column_changed$_varchar2, 8),
          "DESCR9_o",
          dbms_reputil2.choose_varchar2(
              "DESCR9_o",
              "DESCR9_n",
              column_changed$_varchar2, 9),
          "DUCH10_o",
          dbms_reputil2.choose_number(
              "DUCH10_o",
              "DUCH10_n",
              column_changed$_varchar2, 10),
          "KM11_o",
          dbms_reputil2.choose_number(
              "KM11_o",
              "KM11_n",
              column_changed$_varchar2, 11),
          "LM12_o",
          dbms_reputil2.choose_number(
              "LM12_o",
              "LM12_n",
              column_changed$_varchar2, 12),
          "MBEG13_o",
          dbms_reputil2.choose_number(
              "MBEG13_o",
              "MBEG13_n",
              column_changed$_varchar2, 13),
          "MEND14_o",
          dbms_reputil2.choose_number(
              "MEND14_o",
              "MEND14_n",
              column_changed$_varchar2, 14),
          "NL15_o",
          dbms_reputil2.choose_number(
              "NL15_o",
              "NL15_n",
              column_changed$_varchar2, 15),
          "NM16_o",
          dbms_reputil2.choose_number(
              "NM16_o",
              "NM16_n",
              column_changed$_varchar2, 16),
          "NN17_o",
          dbms_reputil2.choose_number(
              "NN17_o",
              "NN17_n",
              column_changed$_varchar2, 17),
          "NT18_o",
          dbms_reputil2.choose_number(
              "NT18_o",
              "NT18_n",
              column_changed$_varchar2, 18),
          "NU19_o",
          dbms_reputil2.choose_number(
              "NU19_o",
              "NU19_n",
              column_changed$_varchar2, 19),
          "PFACT20_o",
          dbms_reputil2.choose_number(
              "PFACT20_o",
              "PFACT20_n",
              column_changed$_varchar2, 20),
          "PPROJ21_o",
          dbms_reputil2.choose_number(
              "PPROJ21_o",
              "PPROJ21_n",
              column_changed$_varchar2, 21),
          "SYSKEY22_o",
          dbms_reputil2.choose_number(
              "SYSKEY22_o",
              "SYSKEY22_n",
              column_changed$_varchar2, 22),
          "USERLAST23_o",
          dbms_reputil2.choose_varchar2(
              "USERLAST23_o",
              "USERLAST23_n",
              column_changed$_varchar2, 23),
          "VFACT24_o",
          dbms_reputil2.choose_number(
              "VFACT24_o",
              "VFACT24_n",
              column_changed$_varchar2, 24),
          "VPROJ25_o",
          dbms_reputil2.choose_number(
              "VPROJ25_o",
              "VPROJ25_n",
              column_changed$_varchar2, 25),
          site_name,
          propagation_flag,
          column_changed$,
          column_sent$_varchar2,
          null) then
          dbms_reputil.rep_end;
          raise;
        end if;
        dbms_reputil.rep_end;
      exception
        when others then
          dbms_reputil.rep_end;
          raise;
      end;
    when dup_val_on_index then
      begin
        if not "UCHASTOK$RR".unique_conflict_update_handler(
          "BUCH1_o",
          dbms_reputil2.choose_number(
              "BUCH1_o",
              "BUCH1_n",
              column_changed$_varchar2, 1),
          "CNEXT2_o",
          dbms_reputil2.choose_number(
              "CNEXT2_o",
              "CNEXT2_n",
              column_changed$_varchar2, 2),
          "CPEREG3_o",
          dbms_reputil2.choose_number(
              "CPEREG3_o",
              "CPEREG3_n",
              column_changed$_varchar2, 3),
          "CPIPELIN4_o",
          dbms_reputil2.choose_number(
              "CPIPELIN4_o",
              "CPIPELIN4_n",
              column_changed$_varchar2, 4),
          "CPRED5_o",
          dbms_reputil2.choose_number(
              "CPRED5_o",
              "CPRED5_n",
              column_changed$_varchar2, 5),
          "CTUCH6_o",
          dbms_reputil2.choose_number(
              "CTUCH6_o",
              "CTUCH6_n",
              column_changed$_varchar2, 6),
          "CUCHPROF7_o",
          dbms_reputil2.choose_number(
              "CUCHPROF7_o",
              "CUCHPROF7_n",
              column_changed$_varchar2, 7),
          "DATELAST8_o",
          dbms_reputil2.choose_date(
              "DATELAST8_o",
              "DATELAST8_n",
              column_changed$_varchar2, 8),
          "DESCR9_o",
          dbms_reputil2.choose_varchar2(
              "DESCR9_o",
              "DESCR9_n",
              column_changed$_varchar2, 9),
          "DUCH10_o",
          dbms_reputil2.choose_number(
              "DUCH10_o",
              "DUCH10_n",
              column_changed$_varchar2, 10),
          "KM11_o",
          dbms_reputil2.choose_number(
              "KM11_o",
              "KM11_n",
              column_changed$_varchar2, 11),
          "LM12_o",
          dbms_reputil2.choose_number(
              "LM12_o",
              "LM12_n",
              column_changed$_varchar2, 12),
          "MBEG13_o",
          dbms_reputil2.choose_number(
              "MBEG13_o",
              "MBEG13_n",
              column_changed$_varchar2, 13),
          "MEND14_o",
          dbms_reputil2.choose_number(
              "MEND14_o",
              "MEND14_n",
              column_changed$_varchar2, 14),
          "NL15_o",
          dbms_reputil2.choose_number(
              "NL15_o",
              "NL15_n",
              column_changed$_varchar2, 15),
          "NM16_o",
          dbms_reputil2.choose_number(
              "NM16_o",
              "NM16_n",
              column_changed$_varchar2, 16),
          "NN17_o",
          dbms_reputil2.choose_number(
              "NN17_o",
              "NN17_n",
              column_changed$_varchar2, 17),
          "NT18_o",
          dbms_reputil2.choose_number(
              "NT18_o",
              "NT18_n",
              column_changed$_varchar2, 18),
          "NU19_o",
          dbms_reputil2.choose_number(
              "NU19_o",
              "NU19_n",
              column_changed$_varchar2, 19),
          "PFACT20_o",
          dbms_reputil2.choose_number(
              "PFACT20_o",
              "PFACT20_n",
              column_changed$_varchar2, 20),
          "PPROJ21_o",
          dbms_reputil2.choose_number(
              "PPROJ21_o",
              "PPROJ21_n",
              column_changed$_varchar2, 21),
          "SYSKEY22_o",
          dbms_reputil2.choose_number(
              "SYSKEY22_o",
              "SYSKEY22_n",
              column_changed$_varchar2, 22),
          "USERLAST23_o",
          dbms_reputil2.choose_varchar2(
              "USERLAST23_o",
              "USERLAST23_n",
              column_changed$_varchar2, 23),
          "VFACT24_o",
          dbms_reputil2.choose_number(
              "VFACT24_o",
              "VFACT24_n",
              column_changed$_varchar2, 24),
          "VPROJ25_o",
          dbms_reputil2.choose_number(
              "VPROJ25_o",
              "VPROJ25_n",
              column_changed$_varchar2, 25),
          site_name,
          propagation_flag,
          column_changed$,
          column_sent$_varchar2,
          null,
          SQLERRM) then
          dbms_reputil.rep_end;
          raise;
        end if;
        dbms_reputil.rep_end;
      exception
        when others then
          dbms_reputil.rep_end;
          raise;
      end;
    when others then
      dbms_reputil.rep_end;
      raise;
  end rep_update;
end "UCHASTOK$RP";
